gchar * key_to_human_readable(gchar * key) {
	gchar * new_key = malloc(strlen(key) + 1);
	/* Used when a hint is not available, often the best description of the option is in the name */
	int i = 0;
	new_key[0] = toupper(key[0]);
        i++;
	while (strlen(key) >= i) {
	  if (key[i] == '_') {
	   new_key[i] = ' ';
	   new_key[i + 1] = toupper(key[i + 1]);
	   i++;
	  } else {
	   new_key[i] = key[i];
	  }
	 i++;
	}

	return new_key;
}

gboolean data_is_in_gslist(GSList * glist, gchar * data) {
  gboolean bool = FALSE;
  GSList * list = glist;

	GSList * starting_gslist = malloc(sizeof(GSList *));
	starting_gslist = glist;

  	while (list) {

     	 /* Process */
		if (!strcmp(list->data, data)) {
		   bool = TRUE;
		}
      	  list = list->next;
  	}
	/* Reset List */
	list = starting_gslist;

  return bool;
}

gboolean key_is_in_option_list(GSList * glist, gchar * data) {
  gboolean bool = FALSE;
  GSList * list = glist;

	GSList * starting_gslist = malloc(sizeof(GSList *));
	starting_gslist = glist;

  		while (list) {
      		/* Process */
			CompizSettingsOption * option = list->data;
			if (!strcmp(option->key, data)) {
		 	  bool = TRUE;
			}
      		 list = list->next;
   		}
	/* Reset List */
	list = starting_gslist;

  return bool;
}


static int strmatch(gchar *string, gchar *stringtm){
	//Rough n Ready string match - fine for what i need
	int i = 0;
	int i2 = 0;

	 while (i < strlen(string)) {
	  //printf("Character %c == %c\n", string[i], stringtm[i2]);
	   if (string[i] == stringtm[i2]) {
	      i2++;
	     if (i2 == strlen(stringtm)) {
	      return 1;
	     }
	   /* Very fast basic regular expression synax %i% to match digit */
	   } else if (stringtm[i2] == '%' && stringtm[i2 + 2] == '%')  {
	    // printf("	Regular expression found\n");
	     if (stringtm[i2 + 1]  == 'i') {
		//printf("	Testing %c for number\n",string[i]);
		if (isdigit(string[i])) {
	          i2 = i2 + 3;
	     	      if (i2 == strlen(stringtm)) {
	      		  return 1;
	     	      }
		}
	     } else if (stringtm[i2 + 1]  == '!') {
		//printf(" Checking for anymore '%c'\n",string[i]);
		
		if (string[i] == '\n' || string[i] == '\0') {
		   //printf("No more found\n");
		   return TRUE;
		} else {
	          i2 = 0;
		}
	     }
	   } else {
	     i2 = 0;
	   }
	  i++;
	 }
		

	return 0;
}

gboolean strmatch_in_gslist(gchar *string, GSList *listtm) {
  if (listtm == NULL) {
	   return TRUE;
  } else {
	//printf("none null list\n");
	for (; listtm; listtm = listtm->next) {
	//printf("%s == %s\n", string, listtm->data);
	  if (strmatch(string, listtm->data)) {
	  //printf("true\n");
	   return TRUE;
	  }
	}
   return FALSE;
  }
}


static char * str_replace (gchar *str, const gchar *search, const gchar *replace) {
  //Replace a string with a string from within a string... :)
  char *p = NULL;
  char *newstr = NULL;

  p = (char *) strstr (str, search);
  if (! p) return (char *) strdup (str);

  newstr = (char *) malloc (strlen (str) + strlen (replace) 
			    - strlen (search) + 10);
  strncpy (newstr, str, p-str);
  newstr[p-str] = 0;
  strcat (newstr, replace);
  p = p + strlen(search);
  if (p)
    strcat (newstr, p);
  
  return newstr;
} 



GSList * add_to_gslist(GSList * list, gchar * string) {
     if (!data_is_in_gslist(list, string)) {
	    list = g_slist_append (list, string);
    }
  return list;
}
   

GSList * remove_from_gslist(GSList * list, gchar * string) {
  GSList * new_list = NULL;
  while (list)
    {
      /* Process */
	  if (strcmp(list->data, string)) {
	    new_list = g_slist_append (new_list, list->data);
	  }
      list = list->next;
    }

   //Free the original list (easier that way)
   g_slist_free(list);

  return new_list;
}
   


GSList * activate_plugin_dependencies(GSList * list, gchar * string) {

 /* First make sure the plugin is not already in the active list */
     if (data_is_in_gslist(list, string)) {
	 return list;
    }

  GSList * load_before_list = NULL;
  load_before_list = (GSList *) CompizSettings_get_load_before_list(string);

  /* Doubt anyones going to have any mroe plugins than that :) */
  int match_position = 99999;

  void find_position(gchar *load_before) {
    printf("Load before %s\n", load_before);
     gboolean match;
     int position = -1;
	void loop_through_active(gchar *plugin) {
	 position++;
         printf("	Compairing %s, %s\n", load_before, plugin);
	 if (!strcmp(load_before, plugin)) {
	  match = TRUE;
	  if (match_position > position) {
	   match_position = position;
	  }
	 
         printf("	Match found so should load plugin at %d position %d\n", position, match_position);
	 }
	}
      g_slist_foreach (active_plugins, (GFunc) loop_through_active, NULL);

   }
  
   g_slist_foreach (load_before_list, (GFunc) find_position, NULL);


  /* Get load after Key */
  GSList * load_after_list = NULL;
  load_after_list = CompizSettings_get_load_after_list(string);


    /* Loop through load after list */
     int highest_position = 0;
     GSList * start = load_after_list;
       while (load_after_list) {
        int position = 1;
	printf("Load after %s\n", (gchar *) load_after_list->data);
	      /* Loop through active plugins */
	       GSList * start2 = active_plugins;
       		  while (active_plugins) {
		   position++;
		   printf("	comparing, %s == %s\n", (gchar *) load_after_list->data, (gchar *) active_plugins->data);
		     if (!strcmp(load_after_list->data, active_plugins->data)) {
			if (position > highest_position) {
			  match_position = position;
			  highest_position = position;
			}
			printf("		Match found at %d so now loading at %d\n", position, match_position);
		     }
	           active_plugins = active_plugins->next;
		  }
		/* end loop */
               active_plugins = start2;
	 load_after_list = load_after_list->next;
       }
     load_after_list = start;
    /* End loop */

 


   /* Finally Inset into list */

	if (match_position == 0) {
	  match_position = -1;
        }

	
   list = g_slist_insert (list, string, match_position - 1);

 
  return list;
}

void activate_plugin(gchar * plugin_name) {
       g_slist_free(active_plugins);
  	active_plugins = backend_get_list_of_active_plugins();
		   active_plugins = activate_plugin_dependencies(active_plugins, plugin_name);
			printf("%s Activated\n", plugin_name);
       backend_set_option ("CompizSettings_general", "allscreens", "active_plugins", (gpointer *)active_plugins, GINT_TO_POINTER(CompizSettingsOptionStringList));
}

void deactivate_plugin(gchar * plugin_name) {
       g_slist_free(active_plugins);
  	active_plugins = backend_get_list_of_active_plugins();
	  	   active_plugins = remove_from_gslist(active_plugins, plugin_name);
			printf("%s De-activated\n", plugin_name);
       backend_set_option ("CompizSettings_general", "allscreens", "active_plugins", (gpointer *)active_plugins, GINT_TO_POINTER(CompizSettingsOptionStringList));
}

void plugin_button_pressed(Plugin_Filter_Button * button) {
	if (button->checkbox_active == FALSE) {
	   button->checkbox_active = TRUE;
	   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button->checkbox), TRUE);
	   activate_plugin(button->plugin_name);
	} else {
	   button->checkbox_active = FALSE;
	   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button->checkbox), FALSE);
	   deactivate_plugin(button->plugin_name);
	}
}

void plugin_toggle_button_pressed(GtkWidget * widget, gchar *plugin_name) {

   		if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(widget))) {		  
			activate_plugin(plugin_name);
   		} else {
			deactivate_plugin(plugin_name);
		}
}


void safe_gtk_widget_destroy(GtkWidget * widget) {
    	if (widget != NULL && GTK_IS_WIDGET(widget)) {
	  gtk_widget_destroy(widget);
	}

     widget = NULL;
}

void safe_gtk_widget_hide(GtkWidget * widget) {
    	if (widget != NULL && GTK_IS_WIDGET(widget)) {
	  gtk_widget_hide(widget);
	}
}

void destroy_filter(Plugin_Filter * filter) {

  /* probably already destroyed if the group was destroyed before as it wil be packed into it */
   safe_gtk_widget_destroy(filter->widget);

     g_slist_free(filter->filter_must_have);

     g_slist_free(filter->filter_must_not_have);


   //g_slist_foreach(filter->filtered_allscreen_options_list, (GFunc) g_free, NULL);
   //g_slist_free(filter->filtered_allscreen_options_list);
 
   //g_slist_foreach(filter->filtered_screen_options_list, (GFunc) g_free, NULL);
   //g_slist_free(filter->filtered_screen_options_list);
  
   //g_free(filter->name);
   //g_free(filter->title);
   //g_free(filter->image);
   g_free(filter);

}

void destroy_option (CompizSettingsOption * option) {
  /* Can't free those because there not pointers */
   if (option->type != CompizSettingsOptionBool && option->type != CompizSettingsOptionInt && option->type != CompizSettingsOptionFloat) {
	if (option->type == CompizSettingsOptionStringList) {
	  g_slist_free((GSList *)option->data);
	} /*else if (option->type == CompizSettingsOptionActionEdge) {
   	  CompizSettingsActionKey * action = option->data;
	   g_free(action->key);
	   g_free(action->button);
	   g_slist_free(action->edge);
	   g_free(action);
	}*/ else {
    	  g_free(option->data);
	}
   }
  g_free(option->key);
  g_free(option->screen);
  g_free(option->plugin_name);
  g_free(option);
}


void destroy_icon_group(IconGroup * group) {
//printf("destroy_icon_group destroying group\n");
    	safe_gtk_widget_destroy(group->container);
    	safe_gtk_widget_destroy(group->eventbox);
    	safe_gtk_widget_destroy(group->table);

	g_free(group->group_name);
	g_slist_foreach(group->icons_list, (GFunc) destroy_filter, NULL);

	g_slist_foreach(group->extra_widgets, (GFunc) safe_gtk_widget_destroy, NULL);
	g_slist_free(group->extra_widgets);

	/* if (group->allscreen_options_list != NULL && group->screen_options_list != NULL) {
	printf("Group !- null\n");
	  g_slist_foreach(group->allscreen_options_list, (GFunc) destroy_option, NULL);
	  g_slist_free(group->allscreen_options_list);
	  g_slist_foreach(group->screen_options_list, (GFunc) destroy_option, NULL);
	  g_slist_free(group->screen_options_list);
	} */

	/* Leave it up to the developer to free ->data he (or she) (probably me) knows what it is */

   g_free(group);

  group = NULL;
	
}


void destroy_group_icons_for_redraw(IconGroup * group) {
    safe_gtk_widget_destroy(group->table);
    group->table = NULL;
   
}

void redraw_icons(IconGroup * group) {
   //printf("redraw_icons destroy table\n");

	/* Some kind of memory curruption or something? */
	if (group != NULL) {
    	   safe_gtk_widget_destroy(group->table);
	}
        //printf("regenerate func destroy table\n");
	(*group->regenerate_func)(group, NULL);

}

void redraw_groups(GSList * group_list) {
//printf("Redrawing group\n");
  backened_remove_callbacks ();
  g_slist_foreach(group_list, (GFunc) destroy_group_icons_for_redraw, NULL);
  //printf("Redrawing icons\n");
  g_slist_foreach(group_list, (GFunc) redraw_icons, NULL);
   //printf("Redrawed\n");
}

void icons_window_resized(GtkWidget *widget, GdkRectangle *allocation, gpointer * user_data) {

  int width = allocation->width - 60;

  if (number_of_cols != (int) (width / ICON_WIDTH)) {
   number_of_cols = (int) (width / ICON_WIDTH);
	if (number_of_cols == 0) {
	  number_of_cols = 1;
	}
   redraw_icons((IconGroup *)user_data);
  }
}

gboolean compiz_is_running() {
   gchar *output = NULL;
   gchar *error = NULL;

   if (g_spawn_command_line_sync("ps -A", &output, &error, NULL, NULL)) {
	/* Fairly big hack */
	if (strmatch(output, "%i%%i% compiz%!%") == TRUE) {
		g_free(output);
		 return TRUE;
	} else {
		g_free(output);
		 return FALSE;
	}
   }

}



gint order_alphabetically(CompizSettingsOption * a, CompizSettingsOption * b) {
   gint num = g_utf8_collate(a->key, b->key);

  return num;
}


void groups_window_resized(GtkWidget *widget, GdkRectangle *allocation, gpointer * user_data) {

  int width = allocation->width - 60;

  if (number_of_cols != (int) (width / ICON_WIDTH)) {
   number_of_cols = (int) (width / ICON_WIDTH);
	if (number_of_cols == 0) {
	  number_of_cols = 1;
	}
   redraw_groups((GSList *)user_data);
  }


  
}

gchar * get_image_path (gchar * plugin_name) {
         gchar * image_path = g_strdup_printf("%s.svg", plugin_name);
 	  if (find_pixmap_file (image_path) != NULL) {
	    return image_path;
	    }

  	   g_free(image_path);
           image_path = g_strdup_printf("%s.png", plugin_name);
 	  if (find_pixmap_file (image_path) == NULL) {
  	   g_free(image_path);
   	    image_path = g_strdup_printf("icon-missing.png");
 	  }

	    return image_path;
}



void plugin_button_clicked(GtkWidget *widget, GdkEventButton *ev, Plugin_Filter_Button * button) {
	//printf("plugin button clicked\n");
	gchar *plugin_name = button->plugin_name;
	if (ev->button == 1) {
	//printf("changin plugin\n");
	    active_plugin_changed(plugin_name);
        } else {
	   if (button->checkbox != NULL) {
	    plugin_button_pressed(button);
	   }
	}

	//printf("button clicked done\n");

}


GtkWidget * current_focus_key = NULL;
GtkWidget * current_focus_mouse = NULL;

void keyboard_shortcut_pressed(GtkWidget *widget, GdkEventKey *key, GtkWidget * entry) {
	gchar * name = egg_virtual_accelerator_name (key->keyval, key->hardware_keycode, key->state);
     if (!(key->is_modifier || strmatch(name, "Super"))) {
	   if (!strcmp(name, "BackSpace") || !strcmp(name, "Escape")) {
	     g_free(name);
	     name = g_strdup_printf("Disabled");
	    } 

		/* Hack for Super */
	        name = str_replace(name, "<Mod4><Hyper>", "<Super>");
	   gtk_entry_set_text (GTK_ENTRY(entry), name);
   	   gdk_keyboard_ungrab (GDK_CURRENT_TIME);
   	   gdk_pointer_ungrab (GDK_CURRENT_TIME);
	   g_signal_handlers_disconnect_by_func(window1, keyboard_shortcut_pressed, entry);
	   g_signal_stop_emission_by_name (G_OBJECT (window1), "key_press_event");

          gtk_button_set_label (GTK_BUTTON(current_focus_key), "Grab Keys");

           current_focus_key = NULL;
	  return;
	}
      g_free(name);
}


void keyboard_grab_key_pressed(GtkWidget * widget, GtkWidget * entry) { 
  current_focus_key = widget;
    gtk_button_set_label (GTK_BUTTON(current_focus_key), "Waiting For Key Press");
	gdk_keyboard_grab(GDK_WINDOW(window1->window), TRUE, GDK_CURRENT_TIME);
	gtk_widget_grab_focus(widget);
        gdk_pointer_grab (window1->window, FALSE, GDK_BUTTON_PRESS_MASK, NULL, NULL, GDK_CURRENT_TIME);
        g_signal_connect ((gpointer) window1, "key_press_event", G_CALLBACK (keyboard_shortcut_pressed),  entry);
}


void mouse_shortcut_pressed(GtkWidget *widget, GdkEventButton *key, GtkWidget * entry) {

	gchar * name = egg_virtual_accelerator_name ((gint) NULL, (gint) NULL, key->state);
	gchar * ButtonString = g_strdup_printf("Button%d", key->button);
	gchar * final_string = g_strdup_printf("%s%s", name, ButtonString);

	if (!strcmp(final_string, "Button1")) {
	   g_free(final_string);
	   final_string = g_strdup_printf("Disabled");

	}
	   	gtk_entry_set_text (GTK_ENTRY(entry), final_string);
   		gtk_button_set_label (GTK_BUTTON(current_focus_mouse), "Grab Mouse");
		gdk_pointer_ungrab (GDK_CURRENT_TIME);	   
		g_signal_handlers_disconnect_by_func(window1, mouse_shortcut_pressed, entry);
	 	g_signal_stop_emission_by_name (G_OBJECT (window1), "button_press_event");

	g_free(name);
	g_free(ButtonString);
	g_free(final_string);
}


void mouse_grab_key_pressed(GtkWidget * widget, GtkWidget * entry) {
  current_focus_mouse = widget;
    gtk_button_set_label (GTK_BUTTON(widget), "Waiting For Mouse Click");
    gdk_pointer_grab (window1->window, FALSE, GDK_BUTTON_PRESS_MASK, NULL, NULL, GDK_CURRENT_TIME);
	gtk_widget_grab_focus(widget);
        g_signal_connect ((gpointer) window1, "button_press_event", G_CALLBACK (mouse_shortcut_pressed),  entry);
}


static gchar * gdkcolor_to_hex(GdkColor *c) {
  /* Convert a GdkColor back to a gdk_color_parse compatible hex value.
   * Returns a freshly allocated buffer that should be freed.
   */
  return g_strdup_printf("#%02X%02X%02X", c->red >> 8, c->green >> 8, c->blue >> 8);
}


/* Should probably filter this out into get_options and get_options_filter */
GSList * backend_apply_option_filter(GSList * list, gchar * plugin_name, gchar * screen, gint option_filter, GSList * must_not_contain, GSList * must_contain) {


/* Applying filter */

  GSList * new_list = NULL;
  /* Return a GSlist all all available options for a plugin on screen xxxxx */

   void entry_to_plugin_path(CompizSettingsOption * option) { 
		  gchar * key_name = g_strdup(option->key);

	//for the string filter plugin_path should be changed to option name (when you can be arsed :)
		    if (option_filter == CompizSettingsOptionIntORFloatORBoolORString && (option->type == CompizSettingsOptionInt || option->type == CompizSettingsOptionColor || option->type == CompizSettingsOptionFloat || option->type == CompizSettingsOptionBool || option->type == CompizSettingsOptionString) && strmatch_in_gslist(key_name, must_contain) && (!strmatch_in_gslist(key_name, must_not_contain) || must_not_contain == NULL)) {

		   new_list = g_slist_append(new_list, option);
		  }  else if (option_filter == (int)NULL && strmatch_in_gslist(key_name, must_contain) && (!strmatch_in_gslist(key_name, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, option);
		  } else if (option_filter == CompizSettingsOptionString && option->type == CompizSettingsOptionString && strmatch_in_gslist(key_name, must_contain) && (!strmatch_in_gslist(key_name, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, option);
		  } else if (option_filter == CompizSettingsOptionBool && option->type == CompizSettingsOptionBool && strmatch_in_gslist(key_name, must_contain) && (!strmatch_in_gslist(key_name, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, option);
		  } else if (option_filter == CompizSettingsOptionAction && option->type == CompizSettingsOptionAction && strmatch_in_gslist(key_name, must_contain) && (!strmatch_in_gslist(key_name, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, option);
		  }

		  g_free(key_name);

   }


   g_slist_foreach(list, (GFunc)entry_to_plugin_path,  NULL);
   new_list = g_slist_sort (new_list, (GCompareFunc)order_alphabetically);

   return new_list;
}


#include "gtk-functions.c"



void filter_text_changed(GtkWidget * widget, gpointer * data) {

     gchar * string = (gchar *) gtk_entry_get_text (GTK_ENTRY(widget));
     global_icon_filter = string;

     redraw_groups(icon_groups);

}
