/* All back end specific stuff should go here, so changes in future can easily be made e.g. switching to dbus */


char *programName;
char **programArgv;
int  programArgc;

char *backgroundImage = "background.png";

int  defaultRefreshRate = 50;
char *defaultTextureFilter = "Good";


REGION   emptyRegion;
REGION   infiniteRegion;
GLushort defaultColor[4] = { 0xffff, 0xffff, 0xffff, 0xffff };
Window   currentRoot = 0;

int lastPointerX = 0;
int lastPointerY = 0;
int pointerX     = 0;
int pointerY     = 0;
char *programName = "compiz_plugin_loader";
extern int  nWindowTypeString;

char *windowTypeString[] = {
    N_("Desktop"),
    N_("Dock"),
    N_("Toolbar"),
    N_("Menu"),
    N_("Utility"),
    N_("Splash"),
    N_("Dialog"),
    N_("Normal"),
    N_("DropdownMenu"),
    N_("PopupMenu"),
    N_("Tooltip"),
    N_("Notification"),
    N_("Combo"),
    N_("Dnd"),
    N_("ModalDialog"),
    N_("Fullscreen"),
    N_("Unknown")
};


int  nWindowTypeString =
    sizeof (windowTypeString) / sizeof (windowTypeString[0]);
/* End Compiz Definitions */
#define COMPIZ_PATH "/apps/compiz"
#define COMPIZ_PLUGINS_PATH COMPIZ_PATH "/plugins"
#define PROGRAM_PATH "/apps/compiz-settings"
#define PROGRAM_PLUGINS_PATH PROGRAM_PATH "/plugins"

enum {
  CompizSettingsOptionString = 1,
  CompizSettingsOptionStringList,
  CompizSettingsOptionInt,
  CompizSettingsOptionFloat,
  CompizSettingsOptionBool,
  CompizSettingsOptionActionKey,
  CompizSettingsOptionActionEdge,
  CompizSettingsOptionActionEdgeButton,
  CompizSettingsOptionActionButton,
  CompizSettingsOptionActionBell,
  CompizSettingsOptionIntORFloatORBoolORString /* mother of all hacks, should only be temporary though*/
};

GConfClient *client;

enum {
  EdgeTopLeft = 1,
  EdgeTop,
  EdgeTopRight,
  EdgeRight,
  EdgeBottomRight,
  EdgeBottom,
  EdgeBottomLeft,
  EdgeLeft,
};

void drawWindowGeometry (CompWindow *w) { }

GSList * Plugins_List = NULL;

static void load_plugin(gchar * path) {

    CompDisplay *d = NULL;

	path = g_strdup_printf("%s", "/usr/lib/compiz/libscale.so");
	void * handle;
    	PluginGetInfoProc getInfo;
    	CompPluginVTable * vt;
	gchar * err;

        handle = dlopen (path, RTLD_NOW);
        if (!handle) {
	//  err=dlerror();
            printf ("%s\n", dlerror());
        } else {
	   printf("Plugin Loaded\n");
	}

	    getInfo = (PluginGetInfoProc) dlsym (handle, "getCompPluginInfo");
 	    if (!getInfo)
 	    {
 	        printf (stderr, _("libberylsettings: dlsym: %s\n"), dlerror());
 	        dlclose(handle);
 	        return;
 	    } else {

 	    	vt=getInfo();
		printf("[plugin name: %s]\n", vt->name);
			printf("	Short Description %s\n", vt->shortDesc);
			printf("	Long Description %s\n", vt->longDesc);
   		if (vt->getDisplayOptions)
 	    	{

			printf("ok\n");
	int n;
 	    for (n=0;n<vt->nDeps;n++)
 	    {

			printf("ok %s\n", vt->deps[n].name);
 	        switch(vt->deps[n].rule)
 	        {

 	            case CompPluginRuleBefore:
 	             //   plugin->load_before=g_slist_append(
 	             //           plugin->load_before,g_strdup(vt->deps[n].name));
 	                break;
 	            case CompPluginRuleAfter:
 	              //  plugin->load_after=g_slist_append(
 	              //          plugin->load_after,g_strdup(vt->deps[n].name));
 	                break;
 	            case CompPluginRuleRequire:
 	              //  plugin->requires=g_slist_append(
//plugin->requires,g_strdup(vt->deps[n].name));
 	                break;
 	            default:
 	                break;
 	        }
 	    }

    if (vt->getDisplayOptions)
 	    {
 	        int n;
 	        CompOption * o = malloc(sizeof(CompOption));
 	        o = (*vt->getDisplayOptions) (d,&n);
 
 	}

   }
	     
}
}

/* START stolen from quinn */
static void load_plugins(gchar * path)
 	/* iterates through $path and adds any plugins found to the context
	            $context        the context to add to
 	            $path           the path to search for plugins (any .so file) */
 	{
 	    GDir * d;
 	    const gchar * n;
 	    d=g_dir_open(path,0,NULL);
 	    if (!d)
 	        return; // no such path
 	    while((n=g_dir_read_name(d)))
 	    {
 	        if (g_str_has_suffix(n,".so") && g_str_has_prefix(n,"lib"))
 	        {
 	            gchar * p;
 	            p=g_strconcat(path,"/",n,NULL);
 	            //actually load the plugin
 	            load_plugin(p);
			printf("load plugin %s\n", p);
 	            g_free(p);
 	        }
 	    }
 	    g_dir_close(d);
 	}
/* END stolen from quinn */


/* Start compiz-settings releated stuff */


//Bit of a gconf hack, got to keep a list of all gconf callbacks which have been setup because when you detroy a gtk widget and then create new ones it doesn't play nice unless the callbacks are first removed. This can be removed when moved to dbus i think
GSList * gconf_notify_ints;

void backened_remove_callbacks () {
	void remove_gconf_notifier(gint *data) {
 		gconf_client_notify_remove (client, (int) data);
 		gconf_notify_ints =g_slist_remove (gconf_notify_ints, data);
	}

 g_slist_foreach(gconf_notify_ints, (GFunc) remove_gconf_notifier, NULL);

}

/* End */



void backend_initial_setup() {

load_plugins("/usr/lib/compiz");

  client = gconf_client_get_default ();
    gconf_client_add_dir (client,
			  COMPIZ_PATH,
			  GCONF_CLIENT_PRELOAD_RECURSIVE,
			  NULL);

    gconf_client_add_dir (client,
			  PROGRAM_PATH,
			  GCONF_CLIENT_PRELOAD_RECURSIVE,
			  NULL);
}


void backend_set_option(gchar * path, gpointer * option, int * type) {
	if (type == GINT_TO_POINTER(CompizSettingsOptionString)) {
	 gconf_client_set_string (client, path, (gchar *) option, NULL);
	} else if (type == GINT_TO_POINTER(CompizSettingsOptionBool)) {
	 gconf_client_set_bool (client, path, (gboolean) option, NULL);
	} else if (type == GINT_TO_POINTER(CompizSettingsOptionInt)) {
	 gconf_client_set_int (client, path, (gint) option, NULL);
	} else if (type == GINT_TO_POINTER(CompizSettingsOptionFloat)) {
	  float float_value = atof ((gchar *) option);
	  gconf_client_set_float (client, path, (float) float_value, NULL);
	} else if (type == GINT_TO_POINTER(CompizSettingsOptionStringList)) {
	 gconf_client_set_list (client, path, GCONF_VALUE_STRING, (GSList *) option, NULL);
	} else {
	 printf("Data type for %s is not supported", path);
	}

}

gpointer * backend_get_option(gchar * path, int * type) {
    gpointer * data;
	if (type == GINT_TO_POINTER(CompizSettingsOptionString)) {
	 data = (gpointer *) gconf_client_get_string (client, path, NULL);
	} else if (type == GINT_TO_POINTER(CompizSettingsOptionBool)) {
	 data = (gpointer *) gconf_client_get_bool (client, path, NULL);
	} else if (type == GINT_TO_POINTER(CompizSettingsOptionInt)) {
	 data = (gpointer *) gconf_client_get_int (client, path, NULL);
	} else if (type == GINT_TO_POINTER(CompizSettingsOptionStringList)) {
	 data = (gpointer *) gconf_client_get_list (client, path, GCONF_VALUE_STRING, NULL);
	} 
    return data;
}


gint * backend_is_action_key(gchar * full_path) {
/* I have speperated this becaause with gconf there is no easily way to detect an action key and i wanted to keep backend_get_option_type() as clean as possible, with dbus it can probably be removed */
gchar * action_extentions[]={
    "_bell",
    "_key",
    "_button",
    "_edgebutton",
    "_edge",
};

int i;
gchar * key;
int  * key_type;
gboolean match = FALSE;
i = 0;
while (i <= 4) {
	key = (gchar *) str_replace(full_path, action_extentions[i], "");
	if (strcmp(key, full_path)) {
	/* Basically replace the key extentions and if the key has changed it means it was that key extension cos it contained that string */
	//printf("%s - %s - %d\n", key, full_path, i);
          if (i == 0) {
	   key_type = GINT_TO_POINTER(CompizSettingsOptionActionBell);
	  } else if ( i == 1) {
	   key_type = GINT_TO_POINTER(CompizSettingsOptionActionKey);
	  } else if ( i == 2) {
	   key_type = GINT_TO_POINTER(CompizSettingsOptionActionButton);
	  } else if ( i == 4) {
	   key_type = GINT_TO_POINTER(CompizSettingsOptionActionEdge);
	  } else if ( i == 3) {
	   key_type = GINT_TO_POINTER(CompizSettingsOptionActionEdgeButton);
	  }
	  match = TRUE;
	  break;
	} else {
	  g_free(key);
	}

i++;
}

gboolean all_other_extensions_exist(gchar *key) {
  i = 0;
	while (i <= 4) {
	   GConfValue * entry;
	   gchar * tmp = g_strdup_printf("%s%s", key, action_extentions[i]);
	   entry = gconf_client_get (client, tmp, NULL);
	   //i != 3 is a backwards compatability hack for schema's that don't have edgebutton
	   if(entry == NULL && i != 3) {
	     return FALSE;
	   }
	   g_free(tmp);
	   gconf_value_free(entry);
		i++;
	}
   return TRUE;
}

 if (match == TRUE) {
  /* Almost certainly an action key, but not reliable enough */
  	if (all_other_extensions_exist(key)) {
  	/*Certainly an action key */
	  return key_type;
  	}
 } else {
  return NULL;
 }


return NULL;

}

GSList * backend_get_list_of_plugins() {
  GSList * Plugins_list;
  /* Whatever backended used this function should return a lower case gslist of all available compiz plugins */
   Plugins_list = gconf_client_all_dirs (client, COMPIZ_PLUGINS_PATH, NULL);
   return Plugins_list;
}

gint * backend_get_option_type(gchar * path) {
    GConfValue * value;
    int option = 0;
	value = gconf_client_get (client, path, NULL);
	gint action_key_tmp = (gint) backend_is_action_key(path);
    	if (action_key_tmp == CompizSettingsOptionActionKey) {
	 option = CompizSettingsOptionActionKey; 
	} else if (action_key_tmp == CompizSettingsOptionActionButton) {
	 option = CompizSettingsOptionActionButton; 
	} else if (action_key_tmp == CompizSettingsOptionActionEdge) {
	 option = CompizSettingsOptionActionEdge; 
	} else if (action_key_tmp == CompizSettingsOptionActionEdgeButton) {
	 option = CompizSettingsOptionActionEdgeButton; 
	} else if (action_key_tmp == CompizSettingsOptionActionBell) {
	 option = CompizSettingsOptionActionBell; 
	} else if (value->type == GCONF_VALUE_STRING) {
	 option = CompizSettingsOptionString; 
	} else if (value->type == GCONF_VALUE_INT) {
	 option = CompizSettingsOptionInt; 
	} else if (value->type == GCONF_VALUE_FLOAT) {
	 option = CompizSettingsOptionFloat; 
	} else if (value->type == GCONF_VALUE_BOOL) {
	 option = CompizSettingsOptionBool; 
	} else {
	//printf("     !! Value type %s unknown (please report)\n", path);
	}
    gconf_value_free(value);

  return (gint *)option;
}


GSList * backend_get_list_of_options(gchar * plugin_name, gchar * screen, gint * option_filter, GSList * must_not_contain, GSList * must_contain) {
  GSList * list;
  GSList * new_list = NULL;
  gchar * key;

   if (!strcmp(plugin_name, "CompizSettings_general")) {
    key = g_strdup_printf(COMPIZ_PATH "/general/%s/options", screen);
   } else {
    key = g_strdup_printf(COMPIZ_PLUGINS_PATH "/%s/%s/options", plugin_name, screen);
   }

  /* Return a GSlist all all available options for a plugin on screen xxxxx */
   list = gconf_client_all_entries (client, key, NULL);


   void entry_to_plugin_path(GConfEntry * entry) { 
		  gchar * plugin_path = g_strdup_printf("%s", entry->key);

	//GSList * must_not_contain = NULL;
	//must_not_contain = g_slist_append(must_not_contain, "fire");


	//for the string filter plugin_path should be changed to option name (when you can be arsed :)

		  if (option_filter == NULL && strmatch_in_gslist(plugin_path, must_contain) && (!strmatch_in_gslist(plugin_path, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, plugin_path);
		  } else if (option_filter == GINT_TO_POINTER(CompizSettingsOptionString) && backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionString) && strmatch_in_gslist(plugin_path, must_contain) && !strmatch_in_gslist(plugin_path, must_not_contain) && strmatch_in_gslist(plugin_path, must_contain) && (!strmatch_in_gslist(plugin_path, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, plugin_path);
		  } else if (option_filter == GINT_TO_POINTER(CompizSettingsOptionBool) && backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionBool) && strmatch_in_gslist(plugin_path, must_contain) && (!strmatch_in_gslist(plugin_path, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, plugin_path);
		  } else if (option_filter == GINT_TO_POINTER(CompizSettingsOptionActionKey) && backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionActionKey) && strmatch_in_gslist(plugin_path, must_contain) && (!strmatch_in_gslist(plugin_path, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, plugin_path);
		  } else if (option_filter == GINT_TO_POINTER(CompizSettingsOptionActionButton) && backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionActionButton) && strmatch_in_gslist(plugin_path, must_contain) && (!strmatch_in_gslist(plugin_path, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, plugin_path);
		  } else if (option_filter == GINT_TO_POINTER(CompizSettingsOptionActionEdge) && backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionActionEdge) && strmatch_in_gslist(plugin_path, must_contain) && (!strmatch_in_gslist(plugin_path, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, plugin_path);
		  }  else if (option_filter == GINT_TO_POINTER(CompizSettingsOptionIntORFloatORBoolORString) && (backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionInt) || backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionFloat) || backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionBool) || backend_get_option_type(plugin_path) == GINT_TO_POINTER(CompizSettingsOptionString)) && strmatch_in_gslist(plugin_path, must_contain) && (!strmatch_in_gslist(plugin_path, must_not_contain) || must_not_contain == NULL)) {
		   new_list = g_slist_append(new_list, plugin_path);
		  } 

		  gconf_entry_free(entry);
		  //g_free(plugin_path);
   }

   g_slist_foreach(list, (GFunc)entry_to_plugin_path,  NULL);
   g_slist_free(list);
    g_free(key);

   new_list = g_slist_sort (new_list, (GCompareFunc)g_utf8_collate);
   return new_list;
}


//The next few functions are going to be the hardest to convert 

void backend_create_new_callback(gchar * key, GFunc * callback_function, GtkWidget * widget) {
	/* Create a new callback to update changes when a widget value is changed */
	gint * notify_int;
	notify_int = (gint *) gconf_client_notify_add (client,
				 key,
				 (GConfClientNotifyFunc)callback_function,
				 widget,
				 NULL,
				 NULL);


	//Hack see gconf_notify_ints
	gconf_notify_ints = g_slist_append (gconf_notify_ints, GINT_TO_POINTER (notify_int)); 
	
	//g_free(notify_int);
}

  /* Create a new callback to notify the widget when settings changes are made external. Not sure if this functionality exists in dbus so mostly gconf specific */
void backend_setting_changed_externally(GConfClient *client,
		    guint        signal,
		    GConfEntry  *entry,
		    gpointer * user_data) {

	GConfValue *value;
	value = gconf_entry_get_value (entry); 
	GtkWidget  *widget = GTK_WIDGET (user_data);
	gchar * widget_type = (gchar *) GTK_OBJECT_TYPE_NAME(widget);

	if (!strcmp(widget_type, "GtkEntry")) {
	  	gchar * new_string;
		 new_string = (gchar *) gconf_value_get_string (value);
		 gtk_entry_set_text(GTK_ENTRY (widget), new_string);
	} else  if (!strcmp(widget_type, "GtkCheckButton")) {
		gboolean bool;
		bool = gconf_value_get_bool (value);
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), bool);
	} else if (!strcmp(widget_type, "GtkHScale")) {
		if (gtk_scale_get_digits(GTK_SCALE(widget)) == 0) {
    	    	  int numb = gconf_value_get_int (value);
	    	  gtk_range_set_value (GTK_RANGE(widget), numb);
	 	} else if (gtk_scale_get_digits(GTK_SCALE(widget)) == 0) {
    	    	  float numb = gconf_value_get_float (value);
	    	  gtk_range_set_value (GTK_RANGE(widget), numb);
	 	}
  	 }  else {
	 printf("Widget %s not supported\n", widget_type);
	}


	//For some reason this causes a seg fault when someone types too fast 
	//gconf_value_free(value); 


}

